<template>
	<div class="layer-bg">
		<div class="mk-order-bg">
			<div class="w-full mx-auto text-center mb-12 px-4 md:px-0">
				<h2
					class="mx-auto w-230 md:w-auto text-black font-secondary-font-regular text-28 md:text-base2 lg:text-5xl leading-8 md:leading-10 lg:leading-56 py-8 md:pt-10 md:pb-4 lg:pt-14 lg:pb-10"
				>
					Register your Molekule
				</h2>
				<p class="font-primary-font-light text-base leading-6 pb-6 lg:pb-4">
					Get better customer support, save on filter refills, and receive special offers and updates.
				</p>
				<p class="justify-center items-center pb-6 md:pb-5 lg:pb-4">
					<span class="font-secondary-font-regular lg:px-2 text-28 md:text-base2 leading-8 md:leading-10 mk-or-text"
						>or</span
					>
				</p>
				<p class="font-primary-font-light text-base leading-6 pb-8 md:pb-6">
					Register with the app by connecting your device.
				</p>
				<div class="flex justify-center gap-x-4">
					<a
						href="https://apps.apple.com/us/app/molekule-the-air-you-were-meant-to-breathe/id1219881640"
						target="_blank"
						><img src="~/assets/images/icon-app-store.svg" class="h-10 mr-9 md:mr-4 lg:mr-6" alt="icon-app-store"
					/></a>
					<a href="https://play.google.com/store/apps/details?id=com.molekule.android" target="_blank"
						><img src="~/assets/images/icon-google-play.svg" class="h-10" alt="icon-google-play"
					/></a>
				</div>
			</div>
			<div class="flex flex-col max-w-screen-xl mx-auto">
				<MkDeviceDetails
					:steps-completed="stepsCompleted"
					:value="deviceDetails"
					:title="accountTitle"
					@completedstep="completedstep"
					@input="updateDetails"
					@change-view="changeView"
					@edit-device="editDevice"
				/>
				<MkCreateAccount
					class="md:mb-28 lg:mb-32"
					:steps-completed="stepsCompleted"
					:value="accountDetails"
					:title="accountTitle"
					@sign-in="userExist"
					:deviceDetails="deviceDetails"
					@device-register-fail="deviceRegisterFail"
				/>
			</div>
		</div>
	</div>
</template>
<script>
import { mapState } from 'vuex';
import MkDeviceDetails from '~/components/D2C/organisms/MkDeviceDetails.vue';
import MkCreateAccount from '~/components/D2C/molecules/MkCreateAccount.vue';
export default {
	name: 'Register',
	components: {
		MkDeviceDetails,
		MkCreateAccount,
	},
	layout: 'aurora-layout',
	data() {
		return {
			stepsCompleted: 1,
			deviceDetails: {
				serialNumber: '',
				purchaseDate: '',
			},
			accountDetails: {},
			editing: false,
			previousStepsCompleted: null,
			accountTitle: 'Create account',
		};
	},
	computed: {
		...mapState('USER_STORE', ['AUTHENTICATED', 'CUSTOMER_EMAIL', 'DEVICE']),
	},
	watch: {
		AUTHENTICATED: {
			deep: true,
			handler() {
				this.setAccount();
			},
		},
	},
	mounted() {
		this.setAccount();
	},
	methods: {
		completedstep() {
			if (!this.editing) {
				if (this.stepsCompleted !== 2) {
					this.stepsCompleted++;
				}
			} else {
				this.editing = false;
				this.stepsCompleted = this.previousStepsCompleted;
			}
		},
		updateDetails(value) {
			this.deviceDetails = value;
		},
		changeView(value) {
			if (!value) {
				this.accountTitle = 'Device details';
			} else {
				this.accountTitle = 'Create account';
			}
			this.deviceDetails = {};
		},
		setAccount() {
			if (this.AUTHENTICATED) {
				this.stepsCompleted = 2;
				this.accountTitle = 'Device details';
			}
		},
		editDevice() {
			this.stepsCompleted = 1;
			if (this.AUTHENTICATED) {
				this.deviceDetails.email = this.CUSTOMER_EMAIL;
			}
		},
		userExist(value) {
			this.stepsCompleted = 1;
			this.deviceDetails.email = value.quick_reg_email_address || '';
			this.accountTitle = 'Device details';
			this.accountDetails = {};
			if (this.DEVICE && this.DEVICE.serialNumber) {
				this.accountDetails = {
					purchaseDate: this.DEVICE.purchaseDate,
					serialNumber: this.DEVICE.serialNumber,
					deviceId: this.DEVICE.deviceId,
					gift: this.DEVICE.gift,
				};
			}
		},
		deviceRegisterFail(value) {
			this.accountTitle = 'Device details';
			this.deviceDetails = {}
			this.accountDetails = {};
			if(value){
				this.accountDetails = value;
			}
		}
	}
};
</script>
<style lang="postcss">
@media screen and (max-width: 767px) {
	.mk-order-bg {
		background: linear-gradient(to bottom, #cfe9db 47%, #f4f2f2 36%);
	}
}

@media screen and (max-width: 1024px) {
	.mk-order-bg {
		background: linear-gradient(to bottom, #cfe9db 40%, #f4f2f2 30%);
	}
}

@media screen and (min-width: 1025px) {
	.mk-order-bg {
		background: linear-gradient(to bottom, #cfe9db 53%, #f4f2f2 37%);
	}
}
</style>
